/*******************************************************************\
 *
 *
 * Author: Blanc Nicolas
 *
 * 
\*******************************************************************/


#ifndef SC_MUTEX_H
#define SC_MUTEX_H

#include <scoot_tags.h>

#include <sc_event.h>


namespace sc_core {

#ifndef SCOOT_SKIP_NOTIFICATION_PHASES
  class sc_mutex
  {
    public:
      sc_mutex():locked(false){}
      explicit sc_mutex(const char*):
        locked(false){}

      int lock()
      {
        while(locked)
        {
          wait(e);
        }
        locked = true;
        return 0;
      }

      int trylock()
      {
        if(locked)
          return -1;
        locked = true;
        return 0;
      }

      int unlock()
      {
        if(!locked)return -1;
        locked = false;
        e.notify();
        return 0;
      }

    private:

      sc_mutex(const sc_mutex&); // Disabled
      sc_mutex& operator=(const sc_mutex&); // Disabled

      sc_event e;
      bool locked;
  };
#endif
}
#endif
