#ifndef TLM_FIFO_PORTS_H
#define TLM_FIFO_PORTS_H

#include <tlm_fifo.h>

namespace tlm {

class tlm_fifo_port_base: scoot_port
{
    public:

    tlm_fifo_port_base()
    {
    }

    explicit tlm_fifo_port_base(char * name)
    {
    }

    private:
    tlm_fifo_port_base(const tlm_fifo_port_base&); // Disabled
};




template <class T>
class tlm_fifo_in: tlm_fifo_port_base
{
    public:

    tlm_fifo_in(){};
    explicit tlm_fifo_in( const char* ){};

    void get( T& t)
    {
        ((tlm_fifo<T>*)channel)->get(t);
    }

    T get()
    {
        return ((tlm_fifo<T>*)channel)->get();
    }

    bool nb_get( T& t)
    {
        return ((tlm_fifo<T>*)channel)->nb_get(t);
    }

    void peek( T& t) const
    {
        ((tlm_fifo<T>*)channel)->peek(t);
    }

    T peek() const
    {
        return ((tlm_fifo<T>*)channel)->peek();
    }

    void operator()(tlm_fifo<T>& f)
    { scoot_port_to_channel_binding(this,&f); }

    void operator()(tlm_fifo_in<T>& p)
    { scoot_port_to_port_binding(this,&p); }

    private:
    // Disabled
    tlm_fifo_in( const tlm_fifo_in<T>& );
    tlm_fifo_in<T>& operator= ( const tlm_fifo_in<T>& );

};

template <class T>
class tlm_fifo_nb_in: tlm_fifo_port_base
{
    public:

    tlm_fifo_nb_in(){};
    explicit tlm_fifo_nb_in( const char* ){};

    bool nb_get( T& t)
    {
        return ((tlm_fifo<T>*)channel)->nb_get(t);
    }

    bool nb_peek( T& t) const
    {
        return ((tlm_fifo<T>*)channel)->nb_peek(t);
    }

    void operator()(tlm_fifo<T>& f)
    { scoot_port_to_channel_binding(this,&f); }

    void operator()(tlm_fifo_nb_in<T>& p)
    { scoot_port_to_port_binding(this,&p); }

    private:
    // Disabled
    tlm_fifo_nb_in( const tlm_fifo_nb_in<T>& );
    tlm_fifo_nb_in<T>& operator= ( const tlm_fifo_nb_in<T>& );

};

template <class T>
class tlm_fifo_out: tlm_fifo_port_base
{
    public:

    tlm_fifo_out(){};
    explicit tlm_fifo_out( const char* ){};

    void put(const T& t)
    {
        ((tlm_fifo<T>*)channel)->put(t);
    }

    bool nb_put(const T& t)
    {
        return ((tlm_fifo<T>*)channel)->nb_put(t);
    }


    void operator()(tlm_fifo<T>& f)
    { scoot_port_to_channel_binding(this, &f); }

    void operator()(tlm_fifo_out<T>& p)
    { scoot_port_to_port_binding(this,&p); }

    private:
    // Disabled
    tlm_fifo_out( const tlm_fifo_out<T>& );
    tlm_fifo_out<T>& operator= ( const tlm_fifo_out<T>& );

};


template <class T>
class tlm_fifo_nb_out: tlm_fifo_port_base
{
    public:

    tlm_fifo_nb_out(){};
    explicit tlm_fifo_nb_out( const char* ){};

    bool nb_put(const T& t)
    {
        return ((tlm_fifo<T>*)channel)->nb_put(t);
    }


    void operator()(tlm_fifo<T>& f)
    { scoot_port_to_channel_binding(this, &f); }

    void operator()(tlm_fifo_nb_out<T>& p)
    { scoot_port_to_port_binding(this,&p); }

    private:
    // Disabled
    tlm_fifo_nb_out( const tlm_fifo_nb_out<T>& );
    tlm_fifo_nb_out<T>& operator= ( const tlm_fifo_nb_out<T>& );

};

} // namespace sc_core

#endif
